/* XNibbles - A simple X11 snake game
   Copyright (C) 1998 Sean MacIsaac and Ian Peters
  
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
  
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
  
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software Foundation,
   Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
  
   Specific questions about this program can be addressed to the authors,
   Sean Macisaac (sjm@acm.org), and Ian Peters (ipeters@acm.org). */

class worm {
  private :
    bodyPart *head;
    bodyPart *spareHead;
    Pixmap wormImage;
    int dx, dy;
    int already;
    int hit();
    int growing;
    int shrinking;
    int score;
    int dscore;
    int lives;
    statusBar *myBar;
    int length; 
    int up, down, left, right;
    int meltCount;
    int meltFlag;
    int flashCount;
    int flashDelay;

  public :
    worm(int aup, int adown, int aleft, int aright, char *aName, int x1, int y1, int which);
    ~worm();
    void showStatusMaybe();
    void showStatus(int which);
    int move();
    int addPartMove();
    int changeDir(int key);
    void drawAll();
    void eraseAll();
    int moveOrGrow();
    void setGrow(int growing1);
    void setShrink(int shrinking1);
    int getLives();
    int getScore();
    void setLives(int alives);
    void setRealScore(int fibbee);
    void setScore(int fibbee);
    void newLevel(char x1, char y1, int dx1, int dy1);
    void cutInHalf();
    void doubleIt();
    int melt();
    void resetMelt();
    int unPause();
};
